/*
    $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/include/RCS/type.h,v 5.6 1996/04/26 08:20:14 jpo Exp $
    $Date: 1996/04/26 08:20:14 $
    $Author: jpo $
    $Id: type.h,v 5.6 1996/04/26 08:20:14 jpo Exp $
    $Locker:  $
    $Log: type.h,v $
    Revision 5.6  1996/04/26 08:20:14  jpo
    MIS_ORDER

    Revision 5.5  1996/04/26 07:44:46  jpo
    Add stdlib.h

    Revision 5.4  1996/04/23 07:58:02  jpo
    New land state

    Revision 5.3  1996/04/23 06:56:55  jpo
    Add new ship tasks to allow loading.

    Revision 5.2  1995/09/08 06:52:52  jpo
    some more structures

 * Revision 5.1  93/03/14  16:40:00  etienne
 * 
 * 
 * Revision 5.0  93/02/06  09:25:20  greyhelm
 * Fixed backward compatabilty with Merc/KSU
 * Changed MOTD to show new version and authors
 * 
 * Revision 4.4  1993/02/06  04:17:12  greyhelm
 * Added RCS headers - Karl Hagen
 *

*/
	/*
	 *	Empiretool	<type.h>
	 *
	 *	Written by HJ Visscher.
	 */

#ifndef _TYPE
#define _TYPE

#ifndef _CONFIG_H_
#include "config.h"
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#else
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#include <stdio.h>
#include <sys/types.h>
#include <ctype.h>
#include "prototype.h"

#define ENTRYPTR	char *
#define DLISTPTR	char *

struct s_funcbutton;		/* forward ref */
typedef struct _Stack *Stack;
struct _EvalStack;

typedef struct s_strings 	* Strings;
typedef struct s_sector1 	* Sector;
typedef struct s_ship		* Ship;
typedef struct l_land		* Land;
typedef struct s_plane  	* Plane;
typedef struct s_nuke   	* Nuke;
typedef struct s_nuke   	* Stockp;
typedef struct s_nation 	* Nation;
typedef struct s_wininfo 	* WinInfo;
typedef struct s_menu 		* Menu;
typedef struct s_shtype		  ShType;
typedef struct l_landtype	  LdType;
typedef struct s_pltype		  PlType;
typedef struct s_pager 		* Pager;
typedef struct s_neighb		* Neighb;
typedef FILE			* File;
typedef struct s_slist		* SList;
typedef char 			* DSList;
typedef struct s_realm		* Realm;
typedef int 			  bool;
typedef struct s_ferry * Ferry;
typedef struct _Instruction	* Program;
typedef struct s_relinfo	* RelInfo;
typedef struct s_repinfo	* RepInfo;
typedef struct s_planentry	* PlanEntry;
typedef enum s_task {
	ST_NAVIGATE,
	ST_SCRAP,
	ST_UPGRADE,
	ST_FLEETADD,
	ST_TEND,
	ST_LOADPLANE,
	ST_LOADXPLANE,
	ST_LOADHELI,
	ST_LOADLAND,
	ST_LOADFUEL,
	ST_ORDERS
} ShTask;
typedef enum {
	MIS_FLY,
	MIS_ORDER,
	MIS_BOMB,
	MIS_DROP,
	MIS_DROPMINES,
	MIS_ESCORT,
	MIS_PARADROP,
	MIS_RECON,
	MIS_WINGADD,
	MIS_TRANSPORT,
	MIS_LOADPLANE,
	MIS_LOADXPLANE,
	MIS_LOADHELI
}
	Mission;

typedef enum
{
	LD_MARCH,
	LD_SCRAP,
	LD_LLOADXPLANE,
	LD_LANDTOSHIP,
	LD_ARMYADD,
	LD_ORDERS
}
    LdTask;

typedef void (*MultiProc) _PROTO((char *realm, int quant, char ch));
typedef void (*AgainProc) _PROTO((void));
typedef void (*InfoProc) _PROTO((int x, int y, int i));
typedef const char ** ConstVP;
typedef const char *ConstPtr;

typedef void (*FuncListFnx) _PROTO((Strings strings, int ind, void *data));
typedef struct funclist {
    const char *funcname;
    int funcid;
    FuncListFnx funcptr;
} FuncList;


#define	STARTUP_STATE	0
#define	NORMAL_STATE	1
#define BUFFER_STATE	2	/* Buffer all commands */
#define FORCE_BUF_STATE	3	/* Force buffering most of the commands */
#define	TEST_STATE	4
#define FASTQUIT_STATE	5

#define RETREAT_NONE	0x00
#define RETREAT_DAMAGED	0x01
#define RETREAT_TORPEDOED 0x02
#define RETREAT_BOMBED	0x04
#define RETREAT_SONAAR	0x08
#define RETREAT_DEPTH	0x10
#define RETREAT_HELPLESS 0x20
#define RETREAT_MAX	8
#define RETREAT_MAXSTR	6
	/* extern */

char *malloc ();
int sscanf ();
int printf ();
int fprintf ();
char *ctime ();
char *getpass ();
char *getenv ();
int atoi ();

#ifndef True
#define		True	1
#define		False	0
#endif True

#ifdef mips
extern int errno;		/* needed on MIPS (bsd43 universe) */
#endif

#endif _TYPE
