/* testedb.c -- this tests some of the empire database access functions */

#include <stdio.h>
#define BUFSZ (1024*4)


extern int csync_debug;

char *defaultInput = "csync.dat";
char *fname = 0;
	
int parseArgs(int argc, char **argp)
{
	int i;
	char c, *p;
	int opt;
	extern int optind;

	csync_debug = 0;
	while ((opt = getopt(argc, argp, "d")) != EOF) {
	    switch(opt) {
	    case 'd':
		csync_debug ++;
		break;
	    }
	}
	argc -= optind;
	argp += optind;
	if (argc > 0)
	    fname = *argp;
}

int main(int argc, char **argp)
{
	FILE *f;
	char buf[BUFSZ];

	parseArgs(argc, argp);

	if (!fname) fname = defaultInput;	
	f = fopen(fname,"r+");
	if (!f) {
		perror("cannot open csync.dat");
		exit(1);
	}
	while (fgets(buf, BUFSZ, f)) {
	    edb_parse_c_sync(buf+2);
	}
	fclose(f);
	dumpobj ();
	dumpmaps ();
	exit(0);
}
